package de.proteinms.xtandemparser.Mutater;

/**
 * Created by IntelliJ IDEA.
 * User: Niklaas
 * Date: 08-Jul-2010
 * Time: 09:47:51
 * To change this template use File | Settings | File Templates.
 */
public class Element {

    /**
     * The element
     */
    private String iElement;
    /**
     * The original element
     */
    private String iOriginalElement;
    /**
     * The mass
     */
    private double iMass;
    /**
     * This indicates the type of the element
     * 1 is N-terminal
     * 2 is internal
     * 3 is C-terminal
     */
    private int iType;

    public boolean iModified = false;
    public boolean iNtermModified = false;
    public boolean iCtermModified = false;
    public boolean iInternalModified = false;
    private boolean iNtermRestriction = false;
    private boolean iCtermRestriction = false;
    private boolean iDoubleModified;

    /**
     * Constructor
     *
     * @param aElement The elements
     * @param aMw      The mass
     */
    public Element(String aElement, double aMw, int lType) {
        this.iElement = aElement;
        this.iOriginalElement = aElement;
        this.iMass = aMw;
        this.iType = lType;
    }

    public Element(String lName, double lMass, int lType, String lOriginalElement) {
        this.iElement = lName;
        this.iMass = lMass;
        this.iType = lType;
        this.iOriginalElement = lOriginalElement;
    }

    /**
     * Getter for the element
     *
     * @return String with the element
     */
    public String getElement() {
        return this.iElement;
    }

    /**
     * Getter for the mass
     *
     * @return double with the mass
     */
    public double getMw() {
        return this.iMass;
    }

    /**
     * To string method
     *
     * @return String
     */
    public String toString() {
        String returnString = iElement + "  " + iMass;
        return returnString;
    }

    public void setElement(String lElement) {
        this.iElement = lElement;
    }

    public void setMass(double lMw) {
        this.iMass = lMw;
    }

    public String getOriginalElement() {
        return iOriginalElement;
    }

    public boolean isModified(){
        return iModified;
    }

    public boolean isNtermModified(){
        return iNtermModified;
    }

    public boolean isCtermModified(){
        return iCtermModified;
    }

    public boolean isInternalModified(){
        return iInternalModified;
    }

    public void setModified() {
        this.iModified = true;
    }

    public void setNtermModified() {
        this.iNtermModified = true;
        this.iModified = true;
    }

    public void setCtermModified() {
        this.iCtermModified = true;
        this.iModified = true;
    }

    public void setInternalModified() {
        this.iInternalModified = true;
        this.iModified = true;
    }

    public int getType() {
        return iType;
    }

    public void setNtermRestriction() {
        this.iNtermRestriction = true;
    }

    public boolean isNtermRestriction() {
        return iNtermRestriction;
    }

    public void setCtermRestriction() {
        this.iCtermRestriction = true;
    }

    public boolean isCtermRestriction() {
        return iCtermRestriction;
    }

    public void setDoubleModified(){
        this.iDoubleModified = true;
    }

    public boolean isDoubleModified() {
        return iDoubleModified;
    }
}
