package de.proteinms.xtandemparser.Mutater;


import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: Niklaas
 * Date: 08-Jul-2010
 * Time: 10:11:29
 */

public class Modification {
    /**
     * The element
     */
    private String iName;
    private String iDescription;
    private String iConversion;
    /**
     * The mass
     */
    private double iMass;

    private boolean iNterm = false;
    private boolean iCterm = false;
    private boolean iFixedModification = false;
    private boolean iModifiesEverything = false;
    private Vector<String> iAminoacids = new Vector<String>();


    /**
     * Constructor
     *
     * @param aElement The elements
     * @param aMw      The mass
     */
    public Modification(String aElement, double aMw, boolean lFixedMods) {
        this.iDescription = aElement;
        this.iName = aElement;
        this.iConversion = iName;
        this.iMass = aMw;
        String lTemp = aElement.substring(aElement.indexOf("@") + 1);
        if(lTemp.startsWith("[")){
            iNterm = true;
            lTemp = lTemp.substring(1);
        }
        if(lTemp.endsWith("]")){
            iCterm = true;
            lTemp = lTemp.substring(0, lTemp.length() - 1);
        }
        if(lTemp.length()==0){
            iModifiesEverything = true;
        }else{
            for(int i = 0; i<lTemp.length(); i ++){
                iAminoacids.add(String.valueOf(lTemp.charAt(i)));
            }
        }
        iFixedModification = lFixedMods;
    }

    /**
     * Getter for the element
     *
     * @return String with the element
     */
    public String getName() {
        return this.iName;
    }

    /**
     * Getter for the mass
     *
     * @return double with the mass
     */
    public double getMw() {
        return this.iMass;
    }

    /**
     * To string method
     *
     * @return String
     */
    public String toString() {
        String returnString = iName + " (" + iConversion + ")  " + iMass;
        return returnString;
    }

    public void setConversion(String lConversion) {
        this.iConversion = lConversion;
    }

    public boolean isFixedModification() {
        return iFixedModification;
    }

    public boolean modifies(String element) {
        if(iModifiesEverything){
            return true;
        } else {
            boolean lModifies = false;
            for(int i = 0; i<iAminoacids.size(); i ++){
                if(iAminoacids.get(i).equalsIgnoreCase(element)){
                    lModifies = true;
                }
            }
            return lModifies;
        }
    }

    public String getConversion() {
        if(iFixedModification){
            return iConversion + "*";
        }
        return iConversion;
    }

    public boolean isNterm() {
        return iNterm;
    }

    public boolean isCterm() {
        return iCterm;
    }

    public boolean isInternal() {
        if(!iNterm && !iCterm){
            return true;
        }
        return false;
    }

    public Vector<String> getAminoAcids() {
        return iAminoacids;
    }

    public String getDescription() {
        return iDescription;
    }
}

